/* +++Date last modified: 05-Jul-1997 */

/*
+----------------------------------------------------+
|                Thunderbird Software                |
+----------------------------------------------------+
| Filespec  :  QUEUE.H                               |
| Date      :  August 30, 1994                       |
| Time      :  5:40 PM                               |
| Revision  :  0.0                                   |
+----------------------------------------------------+
| Programmer:  Scott Andrews                         |
| Address   :  5358 Summit RD SW                     |
| City/State:  Pataskala, Ohio                       |
| Zip       :  43062                                 |
+----------------------------------------------------+
| Released to the Public Domain                      |
+----------------------------------------------------+
*/

#ifndef QUEUE__H
#define QUEUE__H

typedef struct { 
   int   size;
   int   head;
   int   tail;
   int   avail;
   char *buffer;
} QUEUE;

#define QueueEmpty(buffer) ((buffer)->head == (buffer)->tail)
#define QueueAvail(buffer) ((buffer)->avail)
#define QueueFree(buffer) (free(buffer))

QUEUE *QueueAlloc(int size);
int QueuePut(QUEUE *buffer, char data);
int QueueGet(QUEUE *buffer);

#endif /* QUEUE__H */
