#ifndef __RS232DEV_H__
#define __RS232DEV_H__

#include "uip.h"

void rs232dev_init(void);
void rs232dev_close(void);
u8_t rs232dev_read(void);
void rs232dev_send(void);

#if UIP_BUFSIZE > 255
u16_t rs232dev_poll(void);
#else 
u8_t rs232dev_poll(void);
#endif /* UIP_BUFSIZE > 255 */

#endif /* __RS232DEV_H__ */
